package de.akquinet.jbosscc.needle.seam;

import java.io.Serializable;

import org.jboss.seam.core.Interpolator;
import org.jboss.seam.log.Log;

/**
 * Mock class for a logger doing nothing.
 */
public class MockLog implements Log, Serializable {
    private static final long serialVersionUID = 1L;

    private boolean verbose = false;

    public void setVerbose(boolean verbose) {
        this.verbose = verbose;
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     */
    public final void debug(final Object arg0, final Object... arg1) {
        if (verbose) {
            System.out.println(interpolate(arg0, arg1));
        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     * @param arg2 --
     *             not relevant
     */
    public final void debug(final Object arg0, final Throwable arg1, final Object... arg2) {
        if (verbose) {
            System.out.println(arg0);
            arg1.printStackTrace();
        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     */
    public final void error(final Object arg0, final Object... arg1) {
        if (verbose) {
            System.out.println(interpolate(arg0, arg1));
        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     * @param arg2 --
     *             not relevant
     */
    public final void error(final Object arg0, final Throwable arg1, final Object... arg2) {
        if (verbose) {
            System.out.println(arg0);
            arg1.printStackTrace();

        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     */
    public final void fatal(final Object arg0, final Object... arg1) {
        if (verbose) {
            System.out.println(interpolate(arg0, arg1));
        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     * @param arg2 --
     *             not relevant
     */
    public final void fatal(final Object arg0, final Throwable arg1, final Object... arg2) {
        if (verbose) {
            System.out.println(arg0);
            arg1.printStackTrace();

        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     */
    public final void info(final Object arg0, final Object... arg1) {
        if (verbose) {
            System.out.println(interpolate(arg0, arg1));
        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     * @param arg2 --
     *             not relevant
     */
    public final void info(final Object arg0, final Throwable arg1, final Object... arg2) {
        if (verbose) {
            System.out.println(arg0);
            arg1.printStackTrace();

        }
    }

    public final boolean isDebugEnabled() {
        return true;
    }

    public final boolean isErrorEnabled() {
        return true;
    }

    public final boolean isFatalEnabled() {
        return true;
    }

    public final boolean isInfoEnabled() {
        return true;
    }

    public final boolean isTraceEnabled() {
        return true;
    }

    public final boolean isWarnEnabled() {
        return true;
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     */
    public final void trace(final Object arg0, final Object... arg1) {
        if (verbose) {
            System.out.println(interpolate(arg0, arg1));
        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     * @param arg2 --
     *             not relevant
     */
    public final void trace(final Object arg0, final Throwable arg1, final Object... arg2) {
        if (verbose) {
            System.out.println(arg0);
            arg1.printStackTrace();

        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     */
    public final void warn(final Object arg0, final Object... arg1) {
        if (verbose) {
            System.out.println(interpolate(arg0, arg1));
        }
    }

    /**
     * Empty implementation.
     *
     * @param arg0 --
     *             not relevant
     * @param arg1 --
     *             not relevant
     * @param arg2 --
     *             not relevant
     */
    public final void warn(final Object arg0, final Throwable arg1, final Object... arg2) {
        if (verbose) {
            System.out.println(arg0);
            arg1.printStackTrace();

        }
    }

    private Object interpolate(Object object, Object... params) {
        if (object instanceof String) {
            return Interpolator.instance().interpolate((String) object, params);
        } else {
            return object;
        }
    }

}
